Package org.apache.sysds.hops.codegen.cplan

# Class CNodeOuterProduct

java.lang.Object
org.apache.sysds.hops.codegen.cplan.CNode
org.apache.sysds.hops.codegen.cplan.CNodeTpl
org.apache.sysds.hops.codegen.cplan.CNodeOuterProduct

All Implemented Interfaces:
  `Cloneable`

public class CNodeOuterProduct extends CNodeTpl

## Constructor Summary

Constructors
Constructor
Description
`CNodeOuterProduct(ArrayList<CNode> inputs, CNode output, MMTSJ.MMTSJType mmtsj)`

## Method Summary

Modifier and Type
Method
Description
`CNodeTpl`
`clone()`
`String`
`codegen(boolean sparse, SpoofCompiler.GeneratorAPI api)`
`int`
`compile(SpoofCompiler.GeneratorAPI api, String src)`
`boolean`
`equals(Object o)`
`MMTSJ.MMTSJType`
`getMMTSJtype()`
`SpoofOuterProduct.OutProdType`
`getOutProdType()`
`SpoofFusedOp.SpoofOutputDimsType`
`getOutputDimType()`
`String`
`getTemplateInfo()`
`int`
`hashCode()`
`boolean`
`isSupported(SpoofCompiler.GeneratorAPI api)`
`boolean`
`isTransposeOutput()`
`void`
`renameInputs()`
`void`
`setOutProdType(SpoofOuterProduct.OutProdType type)`
`void`
`setOutputDims()`
`void`
`setTransposeOutput(boolean transposeOutput)`

### Methods inherited from class org.apache.sysds.hops.codegen.cplan.CNodeTpl

`addInput, codegen, getBeginLine, getGeneratorAPI, getInputHopIDs, getInputNames, resetVisitStatus, resetVisitStatusOutputs, rReorderCommutativeBinaryOps, setBeginLine, setGeneratorAPI`

### Methods inherited from class org.apache.sysds.hops.codegen.cplan.CNode

`createVarname, createVarname, getClassname, getDataType, getID, getInput, getNumCols, getNumRows, getOutput, getVarname, getVarname, getVectorLength, isGenerated, isLiteral, isVisited, resetGenerated, resetHash, resetVisitStatus, setDataType, setLiteral, setNumCols, setNumRows, setOutput, setVarName, setVisited, setVisited`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CNodeOuterProduct

public CNodeOuterProduct(ArrayList<CNode> inputs, CNode output, MMTSJ.MMTSJType mmtsj)

## Method Details

### getMMTSJtype

public MMTSJ.MMTSJType getMMTSJtype()

### renameInputs

public void renameInputs()

Specified by:
  `renameInputs` in class `CNodeTpl`

### codegen

public String codegen(boolean sparse, SpoofCompiler.GeneratorAPI api)

Specified by:
  `codegen` in class `CNode`

### setOutProdType

public void setOutProdType(SpoofOuterProduct.OutProdType type)

### getOutProdType

public SpoofOuterProduct.OutProdType getOutProdType()

### setOutputDims

public void setOutputDims()

Specified by:
  `setOutputDims` in class `CNode`

### setTransposeOutput

public void setTransposeOutput(boolean transposeOutput)

### isTransposeOutput

public boolean isTransposeOutput()

### getOutputDimType

public SpoofFusedOp.SpoofOutputDimsType getOutputDimType()

Specified by:
  `getOutputDimType` in class `CNodeTpl`

### clone

public CNodeTpl clone()

Specified by:
  `clone` in class `CNodeTpl`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `CNodeTpl`

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `CNodeTpl`

### getTemplateInfo

public String getTemplateInfo()

Specified by:
  `getTemplateInfo` in class `CNodeTpl`

### isSupported

public boolean isSupported(SpoofCompiler.GeneratorAPI api)

Specified by:
  `isSupported` in class `CNode`

### compile

public int compile(SpoofCompiler.GeneratorAPI api, String src)

Specified by:
  `compile` in class `CNodeTpl`